<?php
include_once dirname(__FILE__)."/mainresource/functions.php";

define("TMINUTE",60);
define("THOUR",3600);
define("TDAY",86400);

function downloademail()
{
	$listmail = listmailbulk();
	foreach($listmail as $key=>$data)
	{
		$blogid = $data['blogid'];
		$email = $data['value'];
		$profile = substr($data['variable'],strlen('post_mail_username_'));
		$post_category = getprofile('post_mail_category_'.$profile,$blogid);
		$post_status = getprofile('post_mail_status_'.$profile,$blogid);
		$post_comment = getprofile('post_mail_comment_'.$profile,$blogid);
		$post_commentapproval = getprofile('post_mail_commentapproval_'.$profile,$blogid);
		$server = getprofile('post_mail_server_'.$profile,$blogid);
		$port = getprofile('post_mail_port_'.$profile,$blogid);
		$username = getprofile('post_mail_username_'.$profile,$blogid);
		$password = getprofile('post_mail_password_'.$profile,$blogid);
		$max_width = getprofile("post_mail_max_width_".$profile,$blogid);

		// connect to email
		$pop3 = new KPOP3;
		if(!$pop3->connect($server,$port) || !$pop3->user($username))
		{
			continue;
		}
		$count = $pop3->pass($password);
		if(false===$count)
		{
			// invalid password
			continue;
		}
		if(0===$count)
		{
			$pop3->quit();
			// inbox is empty
			continue;
		}
		for($mailindex = 1; $mailindex<=$count; $mailindex++)
		{
			// fetching content
			$maildata = @implode("",@$pop3->get($mailindex));
			$mailstruct = new KamsMailParser($maildata);

			if(is_array($mailstruct->messages['html']))
			$post_content = implode(" ",$mailstruct->messages['html']);
			else if(strlen($mailstruct->messages['html']))
			$post_content = $mailstruct->messages['html'];

			if(strlen($post_content)<1)
			{
				if(is_array($mailstruct->messages['plain']))
					$post_content = implode(" ",$mailstruct->messages['plain']);
				if(strlen($mailstruct->messages['plain']))
					$post_content = $mailstruct->messages['plain'];
			}
			if(strlen($post_content)<1)
			{
				$pop3->delete($mailindex);
					continue;
				// skip if message is empty
			}

			$mailsender = (!empty($mailstruct->from))?$mailstruct->from:$mailstruct->reply_to;
			
			// who is sender
			$post_user = getuserbyemail($mailsender);
			if(empty($post_user)) 
			{
				// sender not registered
				$sender_alowed = getprofile("post_mail_sender_alowed_".$uid,$blogid,'A');
				if($sender_alowed=='R')
				{
					$pop3->delete($mailindex);
					continue;
					// skip if sender is not registered
				}
				$post_user = $profile;
				$sender_name = $mailstruct->from_name;
				$sender_mail = $mailstruct->from;
			}

			// delivery time
			$post_time = (!empty($mailstruct->delivery))?date("Y-m-d H:i:s",strtotime($mailstruct->delivery)):date("Y-m-d H:i:s");
			
			// title
			$post_title = (!empty($mailstruct->subject))?$mailstruct->subject:"Untitled";
			
			if(stripos($post_content,"<body") !== false)
			{
				$domElement = new DOMDocument;
				$domElement->preserveWhiteSpace = FALSE;
				$domElement->loadHTML($post_content);
				$post_content = get_inner_html($domElement->getElementsByTagName('body')->item(0));
			}
			$post_content = UTF8ToEntities($post_content);
			if(stripos($post_content,"<table") !== false)
			{
				// detect table
				// count how many <td> tag 
				if(substr_count($post_content,"<td")==1)
				{
					// maybe this mail was sent by Yahoo, 
					// remove table if only containing 1 <td> tag then it is alowed to use "image-float-left" or "image-float-right" class
					$post_content = strip_only_tags($post_content,array('table','thead','tbody','tr','td'));
					$class = " class=\"image-float-left\"";
				}
				else
				{
					// not alowed to use "image-float-left" or "image-float-right" class
					$class = "";
				}
			}
			else
			{
				// alowed to use "image-float-left" or "image-float-right" class
				$class = " class=\"image-float-left\"";
			}
			
			// get image and attachment file
			$imageincontent="";
			$attachment="";
			if(is_array($mailstruct->files))
			{
			 	foreach($mailstruct->files as $idx=>$file)
				{
					if(stripos($file['type'],"image")!==false)
					{
						$img = @imagecreatefromstring($file['content']);
						if($img)
						{
							$width = @imagesx($img);
							$height = @imagesy($img);
							$attr_width = $width;
							$attr_height = $height;
							
							if($width > $max_width)
							{
								$attr_width = (int)($max_width);
								$attr_height = (int)($height*$max_width/$width);
							}
						}
						$filename = $file['name'];
						$pad = "";
						$createfile = true;
						while(file_exists(dirname(__FILE__)."/files/$blogid/".$filename))
						{
							if(md5_file(dirname(__FILE__)."/files/$blogid/".$filename) == md5($file['content']))
							{
								$createfile = false;
								break;
							}
							$pad.="2";
							$filename = $file['base_name'].$pad.".".$file['ext'];
						}
						if($createfile)
						{
							$file2create = dirname(__FILE__)."/files/$blogid/".$filename;
							if(!file_exists(dirname(__FILE__)."/files/$blogid"))
							{
								@mkdir(dirname(__FILE__)."/files/$blogid");
								@chmod(dirname(__FILE__)."/files/$blogid",0755);
							}
							$fp = fopen($file2create,"w");
							fwrite($fp, $file['content'],strlen($file['content']));
							fclose($fp);
							@chmod($file2create,0755);
						}
						if($img)
						{
							// add image to content only if it's format is valid
							$attr = "width=\"$attr_width\" height=\"$attr_height\"";
							$imageincontent .= "<img src=\"files/$blogid/$filename\" alt=\"".$file['basename']."\" $attr$class /> ";
						}
						else
						{
							// show attachment link
							$attachment .= "<div class=\"attachment-file\"><a href=\"files/$blogid/$filename\">$filename</a></div> ";
						}
					}
					else
					{
						// add attachment file to content
						$filename = $file['name'];
						$pad = "";
						$createfile = true;
						while(file_exists(dirname(__FILE__)."/files/$blogid/".$filename))
						{
							if(md5_file(dirname(__FILE__)."/files/$blogid/".$filename) == md5($file['content']))
							{
								$createfile = false;
								break;
							}
							$pad.="2";
							$filename = $file['base_name'].$pad.".".$file['ext'];
						}
						if($createfile)
						{
							$file2create = dirname(__FILE__)."/files/$blogid/".$filename;
							if(!file_exists(dirname(__FILE__)."/files/$blogid"))
							{
								@mkdir(dirname(__FILE__)."/files/$blogid");
								@chmod(dirname(__FILE__)."/files/$blogid",0755);
							}
							$fp = @fopen($file2create,"w");
							@fwrite($fp, $file['content'], strlen($file['content']));
							@fclose($fp);
							@chmod($file2create,0755);
						}
						$attachment .= "<div class=\"attachment-file\"><a href=\"files/$blogid/$filename\">$filename</a></div> ";
					}
				}
			}
			
			$post_content = tidyHTML($imageincontent.$post_content.$attachment);
			// add to post
			$vars = array(
			'blogid' => $blogid,
			'title' => $post_title,
			'content' => $post_content,
			'sender' => $post_user,
			'time' => $post_time,
			'category' => $post_category,
			'publish' => $post_status,
			'comment' => $post_comment,
			'commentapproval' => $post_commentapproval,
			'contributor_name' => $sender_name,
			'contributor_mail' => $sender_mail
			);
			addpost($vars);
			// mark mail as deleted
			$pop3->delete($mailindex);
		}
		// quit mail connection and delete marked mail
		$pop3->quit();
	}
}

class KPOP3 {
    var $error      = '';       
    var $timeout    = 60;       
    var $count      = -1;       
    var $buffer     = 512;      
    var $handle     = '';       
    var $mailserver = '';       
    var $debug      = FALSE;    
    var $banner     = '';       
    var $allowapop  = FALSE;    

	function POP3($server = '', $timeout = '') 
	{
        settype($this->buffer,"integer");
        if(!empty($server)) 
		{
            if(empty($this->mailserver))
                $this->mailserver = $server;
        }
        if(!empty($timeout)) 
		{
            settype($timeout,"integer");
            $this->timeout = $timeout;
            if (!ini_get('safe_mode'))
                set_time_limit($timeout);
        }
        return true;
    }

    function update_timer () {
        if (!ini_get('safe_mode'))
            set_time_limit($this->timeout);
        return true;
    }

    function connect ($server, $port = 110)  
	{
		if (!isset($port) || !$port) 
		{
			$port = 110;
		}
        if(!empty($this->mailserver))
            $server = $this->mailserver;

        if(empty($server))
		{
            $this->error = "POP3 connect: " . pop3translate("No server specified");
            unset($this->handle);
            return false;
        }

        $fp = @fsockopen("$server", $port, $errno, $errstr);

        if(!$fp) 
		{
            $this->error = "POP3 connect: " . pop3translate("Error ") . "[$errno] [$errstr]";
            unset($this->handle);
            return false;
        }

        socket_set_blocking($fp,-1);
        $this->update_timer();
        $reply = fgets($fp,$this->buffer);
        $reply = $this->strip_clf($reply);
        if($this->debug)
            error_log("POP3 SEND [connect: $server] GOT [$reply]",0);
        if(!$this->is_ok($reply)) {
            $this->error = "POP3 connect: " . pop3translate("Error ") . "[$reply]";
            unset($this->handle);
            return false;
        }
        $this->handle = $fp;
        $this->banner = $this->parse_banner($reply);
        return true;
    }

    function user ($user = "") 
	{
        if( empty($user) ) 
		{
            $this->error = "POP3 user: " . pop3translate("no login ID submitted");
            return false;
        } 
		else if(!isset($this->handle)) 
		{
            $this->error = "POP3 user: " . pop3translate("connection not established");
            return false;
        } 
		else 
		{
            $reply = $this->send_cmd("USER $user");
            if(!$this->is_ok($reply)) 
			{
                $this->error = "POP3 user: " . pop3translate("Error ") . "[$reply]";
                return false;
            } 
			else
                return true;
        }
    }

    function pass ($pass = "")     
	{
        if(empty($pass)) 
		{
            $this->error = "POP3 pass: " . pop3translate("No password submitted");
            return false;
        } 
		else if(!isset($this->handle)) 
		{
            $this->error = "POP3 pass: " . pop3translate("connection not established");
            return false;
        } 
		else 
		{
            $reply = $this->send_cmd("PASS $pass");
            if(!$this->is_ok($reply)) 
			{
                $this->error = "POP3 pass: " . pop3translate("Authentication failed") . " [$reply]";
                $this->quit();
                return false;
            } 
			else 
			{
                $count = $this->last("count");
                $this->count = $count;
                return $count;
            }
        }
    }

    function apop ($login,$pass) 
	{
        if(!isset($this->handle)) 
		{
            $this->error = "POP3 apop: " . pop3translate("No connection to server");
            return false;
        } 
		else if(!$this->allowapop) 
		{
            $retVal = $this->login($login,$pass);
            return $retVal;
        } 
		else if(empty($login)) 
		{
            $this->error = "POP3 apop: " . pop3translate("No login ID submitted");
            return false;
        } 
		else if(empty($pass)) 
		{
            $this->error = "POP3 apop: " . pop3translate("No password submitted");
            return false;
        } 
		else 
		{
            $banner = $this->banner;
            if((!$banner) || (empty($banner))) 
			{
                $this->error = "POP3 apop: " . pop3translate("No server banner") . ' - ' . pop3translate("abort");
                $retVal = $this->login($login,$pass);
                return $retVal;
            } 
			else 
			{
                $auth_str = $banner;
                $auth_str .= $pass;
                $apop_str = md5($auth_str);
                $cmd = "APOP $login $apop_str";
                $reply = $this->send_cmd($cmd);
                if(!$this->is_ok($reply)) 
				{
                    $this->error = "POP3 apop: " . pop3translate("apop authentication failed") . ' - ' . pop3translate("abort");
                    $retVal = $this->login($login,$pass);
                    return $retVal;
                } 
				else 
				{
                    $count = $this->last("count");
                    $this->count = $count;
                    return $count;
                }
            }
        }
    }

    function login ($login = "", $pass = "") 
	{
        if(!isset($this->handle)) 
		{
            $this->error = "POP3 login: " . pop3translate("No connection to server");
            return false;
        } 
		else 
		{
            $fp = $this->handle;
            if(!$this->user($login)) 
			{
                return false;
            } 
			else 
			{
                $count = $this->pass($pass);
                if((!$count) || ($count == -1)) 
				{
                    return false;
                } 
				else
				{
                    return $count;
				}
            }
        }
    }

    function top($num_message, $num_line = "0") 
	{
        if(!isset($this->handle)) 
		{
            $this->error = "POP3 top: " . pop3translate("No connection to server");
            return false;
        }
        $this->update_timer();

        $fp = $this->handle;
        $buffer = $this->buffer;
        $cmd = "TOP $num_message $num_line";
        fwrite($fp, "TOP $num_message $num_line\r\n");
        $reply = fgets($fp, $buffer);
        $reply = $this->strip_clf($reply);
        if($this->debug) 
		{
            @error_log("POP3 SEND [$cmd] GOT [$reply]",0);
        }
        if(!$this->is_ok($reply))
        {
            $this->error = "POP3 top: " . pop3translate("Error ") . "[$reply]";
            return false;
        }

        $count = 0;
        $arr_msg = array();

        $line = fgets($fp,$buffer);
        while(!ereg("^\.\r\n",$line))
        {
            $arr_msg[$count] = $line;
            $count++;
            $line = fgets($fp,$buffer);
            if(empty($line))    
			{ 
				break; 
			}
        }

        return $arr_msg;
    }

    function pop_list ($num_message = "") 
	{
        if(!isset($this->handle))
        {
            $this->error = "POP3 pop_list: " . pop3translate("No connection to server");
            return false;
        }
        $fp = $this->handle;
        $total_message = $this->count;
        if( (!$total_message) or ($total_message == -1) )
        {
            return false;
        }
        if($total_message == 0)
        {
            return array("0","0");
        }

        $this->update_timer();

        if(!empty($num_message))
        {
            $cmd = "LIST $num_message";
            fwrite($fp,"$cmd\r\n");
            $reply = fgets($fp,$this->buffer);
            $reply = $this->strip_clf($reply);
            if($this->debug) {
                @error_log("POP3 SEND [$cmd] GOT [$reply]",0);
            }
            if(!$this->is_ok($reply))
            {
                $this->error = "POP3 pop_list: " . pop3translate("Error ") . "[$reply]";
                return false;
            }
            list($junk,$num,$size) = preg_split('/\s+/',$reply);
            return $size;
        }
        $cmd = "LIST";
        $reply = $this->send_cmd($cmd);
        if(!$this->is_ok($reply))
        {
            $reply = $this->strip_clf($reply);
            $this->error = "POP3 pop_list: " . pop3translate("Error ") .  "[$reply]";
            return false;
        }
        $arr_msg = array();
        $arr_msg[0] = $total_message;
        for($imsg=1;$imsg <= $total_message; $imsg++)
        {
            if($imsg > $total_message) 
			{ 
			break; 
			}
            $line = fgets($fp,$this->buffer);
            $line = $this->strip_clf($line);
            if(ereg("^\.",$line))
            {
                $this->error = "POP3 pop_list: " . pop3translate("Premature end of list");
                return false;
            }
            list($thisMsg,$msgSize) = preg_split('/\s+/',$line);
            settype($thisMsg,"integer");
            if($thisMsg != $imsg)
            {
                $arr_msg[$imsg] = "deleted";
            }
            else
            {
                $arr_msg[$imsg] = $msgSize;
            }
        }
        return $arr_msg;
    }

    function get ($num_message) 
	{
        if(!isset($this->handle))
        {
            $this->error = "POP3 get: " . pop3translate("No connection to server");
            return false;
        }

        $this->update_timer();

        $fp = $this->handle;
        $buffer = $this->buffer;
        $cmd = "RETR $num_message";
        $reply = $this->send_cmd($cmd);

        if(!$this->is_ok($reply))
        {
            $this->error = "POP3 get: " . pop3translate("Error ") . "[$reply]";
            return false;
        }

        $count = 0;
        $arr_msg = array();

        $line = fgets($fp,$buffer);
        while ( !ereg("^\.\r\n",$line))
        {
            if ( $line{0} == '.' ) { $line = substr($line,1); }
            $arr_msg[$count] = $line;
            $count++;
            $line = fgets($fp,$buffer);
            if(empty($line))    { break; }
        }
        return $arr_msg;
    }

    function last ( $type = "count" ) 
	{
        $last = -1;
        if(!isset($this->handle))
        {
            $this->error = "POP3 last: " . pop3translate("No connection to server");
            return $last;
        }

        $reply = $this->send_cmd("STAT");
        if(!$this->is_ok($reply))
        {
            $this->error = "POP3 last: " . pop3translate("Error ") . "[$reply]";
            return $last;
        }

        $Vars = preg_split('/\s+/',$reply);
        $count = $Vars[1];
        $size = $Vars[2];
        settype($count,"integer");
        settype($size,"integer");
        if($type != "count")
        {
            return array($count,$size);
        }
        return $count;
    }

    function reset() 
	{
        if(!isset($this->handle))
        {
            $this->error = "POP3 reset: " . pop3translate("No connection to server");
            return false;
        }
        $reply = $this->send_cmd("RSET");
        if(!$this->is_ok($reply))
        {
            $this->error = "POP3 reset: " . pop3translate("Error ") . "[$reply]";
            @error_log("POP3 reset: ERROR [$reply]",0);
        }
        $this->quit();
        return true;
    }

    function send_cmd ( $cmd = "" )
    {
        if(!isset($this->handle))
        {
            $this->error = "POP3 send_cmd: " . pop3translate("No connection to server");
            return false;
        }

        if(empty($cmd))
        {
            $this->error = "POP3 send_cmd: " . pop3translate("Empty command string");
            return "";
        }

        $fp = $this->handle;
        $buffer = $this->buffer;
        $this->update_timer();
        fwrite($fp,"$cmd\r\n");
        $reply = fgets($fp,$buffer);
        $reply = $this->strip_clf($reply);
        if($this->debug) { @error_log("POP3 SEND [$cmd] GOT [$reply]",0); }
        return $reply;
    }

    function quit() 
	{
        if(!isset($this->handle))
        {
            $this->error = "POP3 quit: " . pop3translate("connection does not exist");
            return false;
        }
        $fp = $this->handle;
        $cmd = "QUIT";
        fwrite($fp,"$cmd\r\n");
        $reply = fgets($fp,$this->buffer);
        $reply = $this->strip_clf($reply);
        if($this->debug) 
		{ 
			@error_log("POP3 SEND [$cmd] GOT [$reply]",0); 
		}
        fclose($fp);
        unset($this->handle);
        return true;
    }

    function popstat () 
	{
        $PopArray = $this->last("array");

        if($PopArray == -1) 
		{ 
			return false; 
		}

        if((!$PopArray) or (empty($PopArray)))
        {
            return false;
        }
        return $PopArray;
    }

    function uidl ($num_message = "")
    {
        if(!isset($this->handle)) 
		{
            $this->error = "POP3 uidl: " . pop3translate("No connection to server");
            return false;
        }

        $fp = $this->handle;
        $buffer = $this->buffer;

        if(!empty($num_message)) 
		{
            $cmd = "UIDL $num_message";
            $reply = $this->send_cmd($cmd);
            if(!$this->is_ok($reply))
            {
                $this->error = "POP3 uidl: " . pop3translate("Error ") . "[$reply]";
                return false;
            }
            list ($ok,$num,$myUidl) = preg_split('/\s+/',$reply);
            return $myUidl;
        } 
		else 
		{
            $this->update_timer();

            $UIDLArray = array();
            $total_message = $this->count;
            $UIDLArray[0] = $total_message;

            if ($total_message < 1)
            {
                return $UIDLArray;
            }
            $cmd = "UIDL";
            fwrite($fp, "UIDL\r\n");
            $reply = fgets($fp, $buffer);
            $reply = $this->strip_clf($reply);
            if($this->debug) { @error_log("POP3 SEND [$cmd] GOT [$reply]",0); }
            if(!$this->is_ok($reply))
            {
                $this->error = "POP3 uidl: " . pop3translate("Error ") . "[$reply]";
                return false;
            }

            $line = "";
            $count = 1;
            $line = fgets($fp,$buffer);
            while ( !ereg("^\.\r\n",$line)) 
			{
                if(ereg("^\.\r\n",$line)) 
				{
                    break;
                }
                list ($msg,$msgUidl) = preg_split('/\s+/',$line);
                $msgUidl = $this->strip_clf($msgUidl);
                if($count == $msg) 
				{
                    $UIDLArray[$msg] = $msgUidl;
                }
                else
                {
                    $UIDLArray[$count] = 'deleted';
                }
                $count++;
                $line = fgets($fp,$buffer);
            }
        }
        return $UIDLArray;
    }

    function delete ($num_message = "") 
	{
        if(!isset($this->handle))
        {
            $this->error = "POP3 delete: " . pop3translate("No connection to server");
            return false;
        }
        if(empty($num_message))
        {
            $this->error = "POP3 delete: " . pop3translate("No msg number submitted");
            return false;
        }
        $reply = $this->send_cmd("DELE $num_message");
        if(!$this->is_ok($reply))
        {
            $this->error = "POP3 delete: " . pop3translate("Command failed ") . "[$reply]";
            return false;
        }
        return true;
    }
    function is_ok ($cmd = "") 
	{
        if( empty($cmd) )
            return false;
        else
            return( ereg ("^\+OK", $cmd ) );
    }

    function strip_clf ($text = "") 
	{
        if(empty($text))
		{
            return $text;
		}
        else 
		{
            $stripped = str_replace("\r",'',$text);
            $stripped = str_replace("\n",'',$stripped);
            return $stripped;
        }
    }

    function parse_banner ( $server_text ) 
	{
        $outside = true;
        $banner = "";
        $length = strlen($server_text);
        for($count =0; $count < $length; $count++)
        {
            $digit = substr($server_text,$count,1);
            if(!empty($digit))             
			{

                if( (!$outside) && ($digit != '<') && ($digit != '>'))
                {
                    $banner .= $digit;
                }
                if ($digit == '<')
                {
                    $outside = false;
                }
                if($digit == '>')
                {
                    $outside = true;
                }
            }
        }
        $banner = $this->strip_clf($banner);    
        return "<$banner>";
    }
}   

// End KPOP3 Class

class KamsMailParser
{
    var $newline = "\r\n";
    var $header = NULL;
    var $boundary_all = NULL;
    var $boundary_part = NULL;
	var $boundary_prefix = "--";
    var $from = NULL;
    var $from_name = NULL;
	var $to = NULL;
	var $to_name = NULL;
    var $subject = NULL;
	var $content = NULL;
	var $messages = array();
	var $files = array();

	function __construct($data)
    {
        if(empty($data))
        {
            throw new Exception("Email data can not be empty");
        }
        $this->fetch_part($data);
        $this->fetch_content();
        $this->fetch_messages();
        $this->fetch_files();
    }
	
	function mail_message_decode($msg)
	{
		preg_match_all('/=([0-9A-F]){2}/', $msg, $matches, PREG_SET_ORDER); 
		$replace_what = array();
		$replace_with = array();
		if(is_array($matches))
		{
			foreach($matches as $key=>$match)
			{
				if(!in_array($match[0],$replace_what))
				{
					$replace_what[$key]=$match[0];
					$replace_with[$key]=sprintf("%c",hexdec(substr($replace_what[$key],1,2)));
				}
			}
		}
		$msg = str_replace($replace_what,$replace_with,$msg);
		$msg = str_replace("=".$this->newline,"",$msg);
		return $msg;
	}

    function fetch_part($content)
    {
        if ($startpos = stripos($content, "Content-Type:"))
        {
			$startpos = stripos($content, "boundary=\"", $startpos);
            if ($startpos !== false)
            {
                $startpos += strlen("boundary=\"");
                $endpos = stripos($content, "\"", $startpos);
                $this->boundary_all = substr($content, $startpos, $endpos - $startpos);
            }
			else
			{
				// GMail
				$startpos = stripos($content, "boundary=", $startpos);
				if ($startpos !== false)
				{
					$startpos += strlen("boundary=");
					$endpos = stripos($content, $this->newline, $startpos);
					$this->boundary_all = substr($content, $startpos, $endpos - $startpos);
				}
			}
        }
        if (!$this->boundary_all)
        {
            $this->boundary_all = $this->newline.$this->newline;
        }
		$boundary = (!empty($this->boundary_all))?$boundary_prefix.$this->boundary_all:$this->boundary_all;
        $parts = explode($boundary, $content);
        $header1 = array_shift($parts);
        $header2 = array_shift($parts);
        $this->header = $header1 .$boundary. $header2;
        $this->content = implode($parts, $this->boundary_all);
    }

    function fetch_content()
    {
        if (preg_match("/To: (.*)/", $this->header, $match))
        {
            $this->to = $match[1];
            if (preg_match("/.*<(.*)>/", $this->to, $match))
            {
                $this->to_name = $match[0];
                $this->to = $match[1];
            }
        }

        if (preg_match("/From: (.*)/", $this->header, $match))
        {
            $this->from = $match[1];
            if (preg_match("/.*<(.*)>/", $this->from, $match))
            {
                $this->from_name = $match[0];
                $this->from = $match[1];
            }
        }
        if (preg_match("/Reply-to: (.*)/", $this->header, $match))
        {
            $this->reply_to = $match[1];
            if (preg_match("/.*<(.*)>/", $this->reply_to, $match))
            {
                $this->reply_to_name = $match[0];
                $this->reply_to = $match[1];
            }
        }
        if (preg_match("/Subject: (.*)/", $this->header, $match))
        {
            $this->subject = $match[1];
        }
        if (preg_match("/Delivery-date: (.*)/", $this->header, $match))
        {
            $this->delivery = $match[1];
        }
    }

    function fetch_messages()
    {
		$startpos = stripos($this->content, "Content-Type: multipart/alternative");
        if ($startpos !== false)
		{
            if ($startpos = stripos($this->content, "boundary=\"", $startpos))
            {
				// quoted
                $startpos += strlen("boundary=\"");
                $endpos = stripos($this->content, "\"", $startpos);
                $this->boundary_part = substr($this->content, $startpos, $endpos - $startpos);
            }
			else
			{
				if ($startpos = stripos($this->content, "boundary=", $startpos))
				{
					// not quoted
					$startpos += strlen("boundary=");
					$endpos = stripos($this->content, $this->newline, $startpos);
					$this->boundary_part = substr($this->content, $startpos, $endpos - $startpos);
				}
			}
		}
		if(empty($this->boundary_part))
		{
			$this->boundary_part = $this->boundary_all;
		}
		
		$arrcontent = explode($this->boundary_prefix.$this->boundary_part, $this->content);
		$idx_html = 0;
		$idx_plain = 0;
		$idx_file = 0;
		foreach($arrcontent as $part)
		{
			if($startpos = stripos($part, "Content-Type: text/plain;"))
			{
				if(stripos($part, "Content-Disposition: attachment;") !== false)
				{
					continue;
					// attachment file
				}
				$startpos = stripos($part, $this->newline.$this->newline, $startpos);
				$startpos += strlen($this->newline.$this->newline);
				$endpos = strlen($part);
				$msg = trim(substr($part,$startpos,$endpos-$startpos),$this->newline);
				$this->messages['plain'][$idx_plain] = $this->mail_message_decode($msg);
				$idx_plain++;
			}
			
			if($startpos = stripos($part, "Content-Type: text/html;"))
			{
				if(stripos($part, "Content-Disposition: attachment;") !== false)
				{
					continue;
					// attachment file
				}
				$startpos = stripos($part, $this->newline.$this->newline, $startpos);
				$startpos += strlen($this->newline.$this->newline);
				$endpos = strlen($part);
				$msg = trim(substr($part,$startpos,$endpos-$startpos),$this->newline);
				$this->messages['html'][$idx_html] = $this->mail_message_decode($msg);
				$idx_html++;
			}
		}
	}
	
    function fetch_files()
	{
		$boundary = (!empty($this->boundary_all))?$boundary_prefix.$this->boundary_all:$this->boundary_all;
		$arrcontent = explode($boundary, $this->content);
		$idx_file =0;
		foreach($arrcontent as $part)
		{
			if($startpos = strpos($part, "Content-Disposition: attachment;"))
			{
				// quoted
				$startposx = strpos($part, "filename=\"", $startpos);
				if($startposx !== false)
				{
					$startposx = $startposx + strlen("filename=\"");
					$endposx = stripos($part, "\"", $startposx);
					$filename = substr($part, $startposx, $endposx - $startposx);
				}
				else
				{
					// not quoted
					$startposx = strpos($part, "filename=",$startpos);
					$startposx += strlen("filename=");
					$endposx = stripos($part, $this->newline, $startposx);
					$filename = substr($part, $startposx, $endposx - $startposx);
					$filename = trim($filename,"\"\r\n");
				}
				$this->files[$idx_file]['name'] = $filename;
				$parts = explode(".", $this->files[$idx_file]['name']);
				$this->files[$idx_file]['base_name'] = array_shift($parts);
				$this->files[$idx_file]['ext'] = implode(".", $parts);	

				$startposx = strpos($part, "Content-Type: ");
				$startposx += strlen("Content-Type: ");
				$endposx = stripos($part, ";", $startposx);
				$this->files[$idx_file]['type'] = substr($part, $startposx, $endposx - $startposx);
	
				$startposx = strpos($part, "Content-Transfer-Encoding: ");
				$startposx += strlen("Content-Transfer-Encoding: ");
				$endposx = stripos($part, $this->newline, $startposx);
				$this->files[$idx_file]['encoding'] = trim(substr($part, $startposx, $endposx - $startposx));
	
				$startpos = stripos($part, $this->newline.$this->newline, $startpos);
				$startpos += strlen($this->newline.$this->newline);
				$endpos = strlen($part);
				$this->files[$idx_file]['content'] = (substr($part, $startpos, $endpos - $startpos - strlen($this->boundary_prefix)));
				$this->files[$idx_file]['content'] = str_replace($this->newline,"",$this->files[$idx_file]['content']);
				if(stripos($this->files[$idx_file]['encoding'],'base64') !== false)
				{
					$this->files[$idx_file]['content'] = base64_decode($this->files[$idx_file]['content']);
				}
				$idx_file++;
			} 
		}
	}
}

function UTF8ToEntities($string){
if (!ereg("[\200-\237]",$string) && !ereg("[\241-\377]",$string))
	return $string;
$string = preg_replace("/[\302-\375]([\001-\177])/","&#65533;\\1",$string);
$string = preg_replace("/[\340-\375].([\001-\177])/","&#65533;\\1",$string);
$string = preg_replace("/[\360-\375]..([\001-\177])/","&#65533;\\1",$string);
$string = preg_replace("/[\370-\375]...([\001-\177])/","&#65533;\\1",$string);
$string = preg_replace("/[\374-\375]....([\001-\177])/","&#65533;\\1",$string);
$string = preg_replace("/[\300-\301]./", "&#65533;", $string);
$string = preg_replace("/\364[\220-\277]../","&#65533;",$string);
$string = preg_replace("/[\365-\367].../","&#65533;",$string);
$string = preg_replace("/[\370-\373]..../","&#65533;",$string);
$string = preg_replace("/[\374-\375]...../","&#65533;",$string);
$string = preg_replace("/[\376-\377]/","&#65533;",$string);
$string = preg_replace("/[\302-\364]{2,}/","&#65533;",$string);
$string = preg_replace(	"/([\360-\364])([\200-\277])([\200-\277])([\200-\277])/e","'&#'.((ord('\\1')&7)<<18 | (ord('\\2')&63)<<12 |"." (ord('\\3')&63)<<6 | (ord('\\4')&63)).';'",$string);
$string = preg_replace("/([\340-\357])([\200-\277])([\200-\277])/e","'&#'.((ord('\\1')&15)<<12 | (ord('\\2')&63)<<6 | (ord('\\3')&63)).';'",$string);
$string = preg_replace("/([\300-\337])([\200-\277])/e","'&#'.((ord('\\1')&31)<<6 | (ord('\\2')&63)).';'",$string);
$string = preg_replace("/[\200-\277]/","&#65533;",$string);
return $string;
}

function get_inner_html($node)
{ 
    $innerHTML= '';
    $children = $node->childNodes; 
    foreach ($children as $child){ 
        $innerHTML .= $child->ownerDocument->saveXML($child); 
    }
	$innerHTML = str_replace("&#13;","",$innerHTML);
    return $innerHTML; 
}

function getDataInTag($data,$tag,$includingtag=false){
	if(strlen($data))
	{
		if($includingtag)
		{
			$closetag="</".$tag.">";
			$opentag="<".$tag;
			$start_pos=stripos($data,$opentag,0);
			if($start_pos===false)
			return $data;
			$end_pos=stripos($data,$closetag,$start_pos);
			if($end_pos===false)
			return $data;
			$end_pos=stripos($data,">",$end_pos);
			if($end_pos===false)
			return $data;
			$ret=substr($data,$start_pos,($end_pos-$start_pos)+1);
		}
		else
		{
			$closetag="</".$tag.">";
			$opentag="<".$tag;
			$pos1=stripos($data,$opentag,0);
			if($pos1===false)
			return $data;
			$pos1=stripos($data,">",$pos1+strlen($tag)-1)+1;
			$pos2=stripos($data,$closetag);
			if($pos1===false || $pos2===false)
			return $data;
			$ret=substr($data,$pos1,($pos2-$pos1));
		}
		return $ret;
	}
	return null;
}
function pop3translate($var)
{
	return $val;
}
function strip_only_tags($str, $tags, $stripContent=false)
{
    $content = '';
    if(!is_array($tags))
	{
        $tags = (strpos($str, '>') !== false ? explode('>', str_replace('<', '', $tags)) : array($tags));
        if(end($tags) == '') array_pop($tags);
    }
    foreach($tags as $tag) 
	{
        if ($stripContent)
             $content = '(.+</'.$tag.'(>|\s[^>]*>)|)';
         $str = preg_replace('#</?'.$tag.'(>|\s[^>]*>)'.$content.'#is', '', $str);
    }
    return $str;
}
if(getprofile("postviaemail",-1,1))
{
	$ft = getprofile("lastfetchingmailtime",-1,"0000-00-00 00:00:00");
	$ftime = strtotime($ft);
	$ctime = time();
	if( ($ctime-$ftime) > (abs(getprofile("checkmailperiod", -1,5))*TMINUTE) )
	{
		writeprofile("lastfetchingmailtime",date("Y-m-d H:i:s"),-1);
		downloademail();
	}
}
?>